# Copyright 2022 MetaOPT Team. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ==============================================================================

from typing import Any, Callable, Iterable, Mapping, TypeVar, Union

from torch import Tensor


Scalar = TypeVar('Scalar', float, int)
Numeric = Union[Tensor, Scalar]

Schedule = Callable[[Numeric], Numeric]
ScalarOrSchedule = Union[float, Schedule]

# mypy: ignore-errors
TensorTree = Union[Tensor, Iterable['TensorTree'], Mapping[Any, 'TensorTree']]
